<?php

namespace Teknisa\PLA\Modules\Requisicao\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Method;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use \Setforms2\Shared\ORM\DateTime;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use Exception;

class Pla00600RequisicaoServico extends \Teknisa\GER\Controllers\TeknisaCrud  {

	protected $requisicaoServico;
	private $entityManager;
	protected $novoCodigo;
	protected $environment;
	protected $dataSourceManager;
	private $maxNRPRPREVRETI = array();
	protected $libUtilities;

	public function __construct($crudService, $parameterBag, $requisicaoServico, \Doctrine\ORM\EntityManager $entityManager, $novoCodigo, $dataSourceManager, $environment,$libUtilities) {
		$this->crudService       = $crudService;
		$this->parameterBag      = $parameterBag;
		$this->requisicaoServico = $requisicaoServico;
		$this->entityManager     = $entityManager;
		$this->novoCodigo        = $novoCodigo;
		$this->dataSourceManager = $dataSourceManager;
		$this->environment       = $environment;
		$this->libUtilities  = $libUtilities;
	}

	public function calculaRequisicaoServicoPla(DTO\Request\Row $request, DTO\Response $response) {

		try {

			$row = $request->getRow();
	    	if ($row['SERVICOS'] == "T") {
	    		$row['SERVICOS'] = $this->retornaServicos($row);
	    	}

			$cdfilial    = $row['CDFILIAL'];
			$servicos    = $row['SERVICOS'];
			$dtinicial   = $row['DTINICIAL'];
			$dtfinal     = $row['DTFINAL'];
			$peacrescimo = $row['PEACRESCIMO'];
			$cdoperador  = $row['CDOPERADOR'];
			$dthrcalcpr  = $row['DTHRCALCPR'];
			$stdtinicial = $row['STDTINICIAL'];
			$stdtfinal   = $row['STDTFINAL'];
			$idarredond  = $row['IDARREDOND'];
			$idprodutos  = $row['IDPRODUTOS'];
			$nrorg       = $this->environment->getNrOrg();
			$contador    = 'CONSPLAN';
			$nrconsplan  = $this->novoCodigo->getCodeByTableName($contador.$cdfilial, $nrorg);

		   	$this->REQUISICAO_POR_SERVICO_PLA($cdfilial, $servicos, $dtinicial, $dtfinal, $peacrescimo, $cdoperador, $dthrcalcpr,  $stdtinicial, $stdtfinal, $idarredond, $idprodutos, $nrconsplan);
		   	$nrconsplan = array($nrconsplan);
            $response->addDataSet(new DataSet ('nrconsplan', $nrconsplan));

		} catch (\Exception $e) {
             $response->setError(new Error($e->getMessage(), 1));
        }

	}

	public function calculaConsumoPlanejadoPla(DTO\Request\Row $request, DTO\Response $response) {

		try {

			$row = $request->getRow();

	    	if ($row['SERVICOS'] == "T") {
	    		$row['SERVICOS'] = $this->retornaServicos($row);
	    	}

			$filial       = $row['CDFILIAL'];
			$servicos     = $row['SERVICOS'];
			$dtinicial    = $row['DTINICIAL'];
			$dtfinal      = $row['DTFINAL'];
			$idarquivo    = $row['IDARQUIVO'];
			$idprodutos   = $row['IDPRODUTOS'];
			$idsepprato   = $row['IDSEPPRATO'];
			$peacrescimo  = $row['PEACRESCIMO'];
			$idarredond   = $row['IDARREDOND'];
			$cdprodutoini = $row['CDPRODUTOINI'];
			$cdprodutofin = $row['CDPRODUTOFIN'];
			$cdoperador   = $row['CDOPERADOR'];
			$stdtinicial  = $row['STDTINICIAL'];
			$stdtfinal    = $row['STDTFINAL'];
			$nrorg        = $this->environment->getNrOrg();
			$contador     = 'CONSPLAN';
			$nrconsplan   = $this->novoCodigo->getCodeByTableName($contador.$filial, $nrorg);

		   	$this->CONSUMO_PLANEJADO_PLA($filial, $servicos, $dtinicial, $dtfinal, $idarquivo, $idprodutos, $idsepprato, $peacrescimo, $idarredond, $nrconsplan, $cdprodutoini, $cdprodutofin, $cdoperador, $stdtinicial, $stdtfinal);
		   	$nrconsplan = array($nrconsplan);
            $response->addDataSet(new DataSet ('nrconsplan', $nrconsplan));

		} catch (\Exception $e) {
             $response->setError(new Error($e->getMessage(), 1));
        }

	}

	public function REQUISICAO_POR_SERVICO_PLA($cdfilial, $servicos, $dtinicial, $dtfinal, $peacrescimo, $cdoperador, $dthrcalcpr,  $stdtinicial, $stdtfinal, $idarredond, $idprodutos, $nrconsplan) {

        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'REQUISICAO_POR_SERVICO_PLA');
        $procedure->addParam(new Param('CDFILIAL', Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('SERVICOS', Param::PARAM_INPUT, $servicos, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('DTINICIAL', Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('DTFINAL', Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('PEACRESCIMO', Param::PARAM_INPUT, $peacrescimo, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('DTHRCALCPR', Param::PARAM_INPUT, $dthrcalcpr, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('NRCONSPLAN', Param::PARAM_INPUT, $nrconsplan, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('STDTINICIAL', Param::PARAM_INPUT, $stdtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('STDTFINAL', Param::PARAM_INPUT, $stdtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('IDARREDOND', Param::PARAM_INPUT, $idarredond, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('IDPRODUTOS', Param::PARAM_INPUT, $idprodutos, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }

	public function CONSUMO_PLANEJADO_PLA($filial, $servicos, $dtinicial, $dtfinal, $idarquivo, $idprodutos, $idsepprato, $peacrescimo, $idarredond, $nrconsplan, $cdprodutoini, $cdprodutofin, $cdoperador, $stdtinicial, $stdtfinal) {

        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'CONSUMO_PLANEJADO_PLA');
        $procedure->addParam(new Param('FILIAL', Param::PARAM_INPUT, $filial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('SERVICOS', Param::PARAM_INPUT, $servicos, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('DTINICIAL', Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('DTFINAL', Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('IDARQUIVO', Param::PARAM_INPUT, $idarquivo, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('IDPRODUTOS', Param::PARAM_INPUT, $idprodutos, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('IDSEPPRATO', Param::PARAM_INPUT, $idsepprato, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('PEACRESCIMO', Param::PARAM_INPUT, $peacrescimo, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('IDARREDOND', Param::PARAM_INPUT, $idarredond, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('NRCONSPLAN', Param::PARAM_INPUT, $nrconsplan, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('CDPRODUTOINI', Param::PARAM_INPUT, $cdprodutoini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('CDPRODUTOFIN', Param::PARAM_INPUT, $cdprodutofin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('STDTINICIAL', Param::PARAM_INPUT, $stdtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('STDTFINAL', Param::PARAM_INPUT, $stdtfinal, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }

	public function retornaMaxNRPRPREVRETI(DTO\Request\Row $request, DTO\Response $response) {

		try {

			$campos = $request->getRow();
	        $nrorg = $campos['NRORG'];

			$maxNRPRPREVRETI = $this->get_maxNrPrPrevReti($nrorg, $campos);
			$maxNRPRPREVRETI = array($maxNRPRPREVRETI);
			$response->addDataSet(new DataSet ('maxNRPRPREVRETI', $maxNRPRPREVRETI));

		} catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
	}

	public function converteParaDateTime($date) {
		
		$date = explode('/', $date);
		return new DateTime($date[2].'-'.$date[1].'-'.$date[0]);
	}

	public function salvaPrato(DTO\Request\Row $request, DTO\Response $response) {

		try {

			$row = $request->getRow();

			$row['DTPREVRETI'] = $this->converteParaDateTime($row['DTPREVRETI']);
			$row['DTLIMITERETI'] = $this->converteParaDateTime($row['DTLIMITERETI']);

			$prevreti = new \Teknisa\Model\Planejamento\Entities\Prevreti();
			$prevreti = $this->constroiPrevreti($prevreti, $row);
	          //coleta de dados
			$this->libUtilities->saveCollectedData($row['CDFILIAL'],'REQUISICAO');
			$this->entityManager->persist($prevreti);
			$this->entityManager->flush();

		} catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }

	}

	public function salvaProduto(DTO\Request\DataSet $request, DTO\Response $response) {

		try {

			$this->entityManager->getConnection()->beginTransaction();
			$dataRow = $row = $request->getDataSet()->getRows();
			
			foreach ($dataRow as $row) {
				$row['DTPREVRETI'] = $this->converteParaDateTime($row['DTPREVRETI']);
				$row['DTLIMITERETI'] = $this->converteParaDateTime($row['DTLIMITERETI']);
				$row['DTLIMITERETI_backup'] = $this->converteParaDateTime($row['DTLIMITERETI_backup']);
				$validate = [];
				if($row['__is_new']){
					$validate = $this->validaProduto($row);
					if(!empty($validate)){
						throw new Exception($validate['ERROR']);
					}
				} 
				if(empty($validate)){
					
					if(!empty($row['CDTIPOPRAT'])){
						$prevreti = $this->entityManager->getRepository('\Teknisa\Model\Planejamento\Entities\Prevreti')
			            ->findOneBy(array("cdfilial"     => $row['CDFILIAL'], 
			            				  "cdservfili"   => $row['CDSERVFILI'], 
			            				  "dtprevreti"   => $row['DTPREVRETI'], 
			            				  "nrrequextr"   => $row['NRREQUEXTR'], 
			            				  "idprevreti"   => $row['IDPREVRETI'], 
			            				  "cdproduto"    => $row['CDPRODUTO'],
			            				  "cdtipoprat"   => $row['CDTIPOPRAT'],
			            				  "cdfilauxprat" => $row['CDFILAUXPRAT'],
			            				  "cdprato" => $row['CDPRATO']
			            				  ));
			    	}
			    	else{
			    		$prevreti = $this->entityManager->getRepository('\Teknisa\Model\Planejamento\Entities\Prevreti')
			            ->findOneBy(array("cdfilial"     => $row['CDFILIAL'], 
			            				  "cdservfili"   => $row['CDSERVFILI'], 
			            				  "dtprevreti"   => $row['DTPREVRETI'], 
			            				  "nrrequextr"   => $row['NRREQUEXTR'], 
			            				  "idprevreti"   => $row['IDPREVRETI'], 
			            				  "cdproduto"    => $row['CDPRODUTO']
			            				  ));
			    	}
		            
		            if (empty($prevreti)) {
						$newPrevreti = new \Teknisa\Model\Planejamento\Entities\Prevreti();
						$newPrevreti = $this->constroiPrevreti($newPrevreti, $row);
				
			              //coleta de dados
			             $this->libUtilities->saveCollectedData($row['CDFILIAL'],'REQUISICAO');
						$this->entityManager->persist($newPrevreti);
						$this->entityManager->flush();
					

		            } else {
			            //coleta de dados
			            $this->libUtilities->saveCollectedData($row['CDFILIAL'],'REQUISICAO');
						$this->entityManager->persist($this->constroiPrevreti($prevreti, $row));
						$this->entityManager->flush();

		            }
				}
			}
			
			$this->entityManager->getConnection()->commit();
		} catch (\Exception $e) {
			$this->entityManager->getConnection()->rollback();
            $response->setError(new Error($e->getMessage(), 1));
        }

	}

	public function excluiPrato(DTO\Request\Row $request, DTO\Response $response) {

		try {

			$rows = $request->getRow();

			$this->entityManager->getConnection()->beginTransaction();

        	foreach ($rows as $row) {

        		foreach ($row as $prato) {

        			$prato['DTPREVRETI'] = $this->converteParaDateTime($prato['DTPREVRETI']);

		        	$prato = $this->entityManager->getRepository('\Teknisa\Model\Planejamento\Entities\Prevreti')
		            ->findBy(array("cdfilial" => $prato['CDFILIAL'], "cdservfili" => $prato['CDSERVFILI'], "dtprevreti" => $prato['DTPREVRETI'], "idprevreti" => $prato['IDPREVRETI'], "nrorg" => $prato['NRORG'], "cdprato" => $prato['CDPRATO'], "cdtipoprat" => $prato['CDTIPOPRAT']));

		            foreach ($prato as $produto) {

		            	$this->entityManager->remove($produto);

		            }

        		}
        	}

        	$this->entityManager->flush();
        	$this->entityManager->getConnection()->commit();

		} catch (\Exception $e) {
             $response->setError(new Error($e->getMessage(), 1));
        }

	}

	public function salvaMensagem(DTO\Request\Row $request, DTO\Response $response) {

		try {

			$row = $request->getRow();

			$row['DTMENSREQU'] = $this->converteParaDateTime($row['DTMENSREQU']);
			$row['DTULTATU'] = new DateTime();

			$mensrequ = $this->entityManager->getRepository('\Teknisa\Model\Planejamento\Entities\Mensrequ')
            ->findOneBy(array("cdfilial" => $row['CDFILIAL'], "cdservfili" => $row['CDSERVFILI'], "dtmensrequ" => $row['DTMENSREQU'], "nrsequrequ" => $row['NRSEQUREQU'], "nrorg" => $row['NRORG']));

	       //coleta de dados
			$this->libUtilities->saveCollectedData($row['CDFILIAL'],'REQUISICAO');
            if (empty($mensrequ)) {

				$mensrequ = new \Teknisa\Model\Planejamento\Entities\Mensrequ();
				$mensrequ = $this->constroiMensrequ($mensrequ, $row);
				$this->entityManager->persist($mensrequ);
				$this->entityManager->flush();

            } else {

            	$mensrequ = $this->alteraMensrequ($mensrequ, $row);
            	$this->entityManager->persist($mensrequ);
				$this->entityManager->flush();

            }

		} catch (\Exception $e) {
             $response->setError(new Error($e->getMessage(), 1));
        }

	}

	public function retornaServicos($row) {

		$servicos = $this->searchServicos($row);
		if (!empty($servicos)) {
			$servicos = $this->concatena($servicos);
		} else {
			$servicos = null;
		}
		return $servicos;

	}
	
	public function getServicoDataSource(DTO\Request\Filter $request, DTO\Response $response) {

		try {
			$FilterCriteria = ($request->getFilterCriteria());
			$this->dataSourceName = 'pla00700_servicoServoperPorGrupserv';
			$dataSet = $this->crudService->getFilteredDataset("pla00700_servicoServoperPorGrupserv", $FilterCriteria->getConditions());
		    if (empty($dataSet->getRows())){
		    	$conditions = $FilterCriteria->getConditions();
		    	$newConditions = array_filter($conditions, function($condition) {
		    		return $condition["columnName"] != "CDOPERADOR"; 
		    	});
        		$dataSet = $this->crudService->getFilteredDataset("servico_servoper_grupserv", $newConditions);
        	}
		    $response->addDataSet($dataSet);
		} catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
    	}
	}

	public function searchServicos($row) {

		$FilterCriteria = new FilterCriteria('pla00700_servicoServoperPorGrupserv');
        $FilterCriteria->addCondition('CDFILIAL', $row['CDFILIAL']);
        $FilterCriteria->addCondition('NRORG', $this->environment->getNrOrg());
        $FilterCriteria->addCondition('CDOPERADOR', $this->environment->getCdOperador());
        $FilterCriteria->addCondition('CDGRUPSERV', $row['CDGRUPSERV']);
        $this->dataSourceName = 'pla00700_servicoServoperPorGrupserv';
        $this->parameterBagColumns = array('CDFILIAL', 'NRORG', 'CDOPERADOR', 'CDGRUPSERV');
        $FilterCriteria = $this->crudService->populateParameterBag($FilterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($FilterCriteria);
        if (empty($dataSet->getRows())){
        	$conditions = array(
        		array(
        			"columnName" => "CDFILIAL",
        			"operator" => "=",
        			"value" => $row['CDFILIAL']
        		),
        		array(
        			"columnName" => "CDGRUPSERV",
        			"operator" => "=",
        			"value" => $row['CDGRUPSERV']
        		),
        		array(
        			"columnName" => "NRORG",
        			"operator" => "=",
        			"value" => $this->environment->getNrOrg()
        		)
        	);
        	$dataSet = $this->crudService->getFilteredDataset("servico_servoper_grupserv", $conditions);
        }
        return $dataSet->getRows($row);
	}

	public function concatena($servicos) {

            $servicoConcatenado = "_";
            foreach ($servicos as $servico) {
                $servicoConcatenado = $servicoConcatenado . $servico['CDSERVFILI'] . "_";
            }
            return $servicoConcatenado;
      }
      
    public function searchDeliveryPoints($row) {
    	$FilterCriteria = new FilterCriteria('pla00600_pontoDeEntrega');
    	$FilterCriteria->addCondition('CDFILIAL', $row['CDFILIAL']);
    	$FilterCriteria->addCondition('NRORG', $this->environment->getNrOrg());
    	$FilterCriteria->addCondition('CDLISTSERV', $row['CDSERVFILI']);
    	$FilterCriteria->addCondition('CDTODOSERV', $row['CDSERVFILI']);
    	
    	$this->dataSourceName = 'pla00600_pontoDeEntrega';
        $this->parameterBagColumns = array('CDFILIAL', 'NRORG', 'CDLISTSERV', 'CDTODOSERV');
        
        $FilterCriteria = $this->crudService->populateParameterBag($FilterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($FilterCriteria);
        $rows = $dataSet->getRows($row);
        
        $arrayDeliveryPoints = [];
        foreach($rows as $row) {
        	array_push($arrayDeliveryPoints, $row['IDPTENTREGA']);
        }
        
        $deliveryPointsList = implode("_", $arrayDeliveryPoints);
        return $deliveryPointsList;
    	
    }


	public function constroiPrevreti($prevreti, $row) {
	 	$row['DTINCLUSAO'] = empty($row['DTINCLUSAO']) ? new DateTime() : $this->converteParaDateTime(explode(' ', $row['DTINCLUSAO'])[0]);
	 	$row['DTULTATU'] = $this->converteParaDateTime(explode(' ', $row['DTULTATU'])[0]);

        $prevreti->setCdfilial($row['CDFILIAL']);
        $prevreti->setCdservfili($row['CDSERVFILI']);
        $prevreti->setDtprevreti($row['DTPREVRETI']);
        $prevreti->setIdprevreti($row['IDPREVRETI']);
        $prevreti->setCdprato($row['CDPRATO']);
        $prevreti->setCdtipoprat($row['CDTIPOPRAT']);
        $prevreti->setNrrequextr($row['NRREQUEXTR']);
        $prevreti->setNrprprevreti($row['NRPRPREVRETI']);
        $prevreti->setCdproduto($row['CDPRODUTO']);
        $prevreti->setDtlimitereti($row['DTLIMITERETI']);
        $prevreti->setHrlimitereti($row['HRLIMITERETI']);
        $prevreti->setQtprevreti($row['QTPREVRETI']);
        $prevreti->setQtprevextra($row['QTPREVEXTRA']);
        $prevreti->setQtprevdevol($row['QTPREVDEVOL']);
        $prevreti->setQtprevlib($row['QTPREVLIB']);
        $prevreti->setCdfilauxprat($row['CDFILAUXPRAT']);
        $prevreti->setIdativo($row['IDATIVO']);
        $prevreti->setIdprevtpprat($row['IDPREVTPPRAT']);
        $prevreti->setNrorg($row['NRORG']);
        $prevreti->setNrorgultatu($row['NRORGULTATU']);
        $prevreti->setDtinclusao($row['DTINCLUSAO']);
        $prevreti->setDtultatu($row['DTULTATU']);
        $prevreti->setCdoperinclusao($row['CDOPERINCLUSAO']);
        $prevreti->setCdoperultatu($row['CDOPERULTATU']);
        $prevreti->setCdoperador($row['CDOPERADOR']);
        $prevreti->setNrorginclusao($row['NRORGINCLUSAO']);

        return $prevreti;
    }

    public function constroiMensrequ($mensrequ, $row) {

 		$mensrequ->setCdfilial($row['CDFILIAL']);
        $mensrequ->setCdservfili($row['CDSERVFILI']);
        $mensrequ->setDsobsrequ($row['DSOBSREQU']);
        $mensrequ->setDtmensrequ($row['DTMENSREQU']);
        $mensrequ->setNrsequrequ($row['NRSEQUREQU']);
        $mensrequ->setNrorg($row['NRORG']);
        $mensrequ->setNrorginclusao($row['NRORGULTATU']);
        $mensrequ->setNrorgultatu($row['NRORGULTATU']);
        $mensrequ->setDtinclusao($row['DTULTATU']);
        $mensrequ->setDtultatu($row['DTULTATU']);
        $mensrequ->setCdoperinclusao($row['CDOPERULTATU']);
        $mensrequ->setCdoperultatu($row['CDOPERULTATU']);

        return $mensrequ;
    }

    public function alteraMensrequ($mensrequ, $row) {

        $mensrequ->setDsobsrequ($row['DSOBSREQU']);
        $mensrequ->setNrorgultatu($row['NRORGULTATU']);
        $mensrequ->setDtultatu($row['DTULTATU']);
        $mensrequ->setCdoperultatu($row['CDOPERULTATU']);

        return $mensrequ;
    }

    /**
     * Valida a adição de um novo produto.
     * @param Object $row contendo o atributo CDARVPROD
     * @return array $validate retorna um array vazio para permitir a adição
     * ou um array com ERROR contendo a mensagem de erro.
     */
    private function validaProduto($row){
    	$validate = [];
    	$condition = array(
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $this->environment->getCdFilial()
            ),
            array(
            	"columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $row['CDARVPROD']
            )
        );
        $filterCriteria = new FilterCriteria('pla00600_verificaproduto', $condition);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $row = $dataSet->getRows();
        if(!empty($row) && $row[0]['IDPRODATIVPR'] == 'S'){
        	$validate = array(
            	"ERROR" => "Impossível adicionar! Produto não cadastrado para filial ou inativo."
           	);
        } elseif(!empty($row) && $row[0]['IDCNTRESTOQ'] == 'S'){
        	$validate = array(
        		"ERROR" => "Impossível adicionar! O produto não possui controle de estoque"
        	);
        } 
        return $validate;
    }
    
    public function validGrupOper(DTO\Request $request, DTO\Response $response, $operator = null){
    	$cdGrupOper = $this->getGrupOper();
    	$cdOperador = $operator == null ? $this->environment->getCdOperador() : $operator;
    	
    	//Verifica Grupo de operdores cadastrado na tela de parâmetros.
    	$sqlGrupo = "SELECT NRPERFILACESSO FROM AUTPERFILACESSO WHERE IDAUTPERFACESSO = 'ALTREQUSERV'";
    	
    	$queryGrupo  = $this->entityManager->getConnection()->prepare($sqlGrupo);
        $queryGrupo->execute();
        $resultGrupo = $queryGrupo->fetchAll();
        if(!empty($resultGrupo)){
        	$resultGrupo = $resultGrupo[0]["NRPERFILACESSO"];
        	
	    //Verifica se Operador esta no Grupo cadastrado (Mobile)
	    $sqlOperGrup = "SELECT
							OPERADOR.CDOPERADOR,
							OPERADOR.NMOPERADOR,
							PERFACESSPARC.NRPERFILACESSO
						FROM PERFACESSPARC
						JOIN OPERADOR 
							ON ( PERFACESSPARC.NRPARCNEGOCIO = OPERADOR.NRPARCNEGOCIO
							AND PERFACESSPARC.NRORG = OPERADOR.NRORG )
						WHERE NRPERFILACESSO = :NRPERFILACESSO
							AND  OPERADOR.CDOPERADOR = :OPERADOR";
	    $paramsOperGrup = array(
	    	"NRPERFILACESSO" => $resultGrupo,	
	    	"OPERADOR" => $cdOperador
	    );
	    $queryOperGrup  = $this->entityManager->getConnection()->prepare($sqlOperGrup);
	    $queryOperGrup->execute($paramsOperGrup);
	    $resultOperGrup = $queryOperGrup->fetchAll();
	    if(!empty($resultOperGrup)){
	        $resultOperGrup = $resultOperGrup[0]["CDOPERADOR"];
	       }
        }
    	if(empty($resultGrupo)){ //se nao tem perfil de acesso no mobile, verifica no delphi
	    	if(empty($cdGrupOper)){ //se tambem nao tem grupo de operadores cadastrado no delphi, entao todo mundo esta autorizado
	    		$response->addDataSet(new DataSet ('authorized', array($cdOperador)));
	    	}else{
		    	//Verifica se Operador esta no Grupo cadastrado (Delphi)
		    	$sql = "SELECT * FROM OPERGRUPOP WHERE CDGRUPOPER = :CDGRUPOPER AND CDOPERADOR = :CDOPERADOR";
		    	$params = array(
		    		"CDGRUPOPER" => $cdGrupOper,	
		    		"CDOPERADOR" => $cdOperador
		    	);
		    	$query  = $this->entityManager->getConnection()->prepare($sql);
		        $query->execute($params);
		        $result = $query->fetchAll();
	    		
	    		if(!empty($result)){ //se operador esta no grupo do delphi então aprova, senão nao autoriza
	    			$response->addDataSet(new DataSet ('authorized', array($cdOperador)));
	    		}else{
	    			$response->addDataSet(new DataSet ('denied', array($cdOperador)));
	    		}
	    	}
    	}else{
    		if(!empty($resultOperGrup)){ //se tem perfil de acesso cadastrado no mobile e o operador faz parte, aprova, senão reprova
    			$response->addDataSet(new DataSet ('authorized', array($cdOperador)));
    		}else{
    			$response->addDataSet(new DataSet ('denied', array($cdOperador)));
    		}
    	}    
    }
    
    private function getGrupOper(){
    	$sql = "SELECT CDGROPERRESE FROM PARAMGERAL";
    	$query  = $this->entityManager->getConnection()->prepare($sql);
        $query->execute();
        return $query->fetchAll()[0]["CDGROPERRESE"];
    }
    
    public function authOperator(DTO\Request $request, DTO\Response $response) {
		try{

			$row = $request->getRow();

			$operator = $this->findCdOperator($row['EMAIL']);
			if(!empty($row['EMAIL'])){
				$senha = $row['SENHA'];
				$this->validatePassword($operator, $row['SENHA']);
			}
			$this->validGrupOper($request, $response, $operator);

	    //	$response->addDataSet(new DataSet ('authorized', array($operator)));
		    
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function findCdOperator($email) {
		$dataSourceName = 'operador';
		$conditions = array(
			array(
				'columnName' => 'DSEMAILOPER',
				'operator' => 'LIKE',
				'value' => $email
			)
		);
		$dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
		if(empty($dataSet)){
			throw new \Exception("Operador não cadastrado", 1);
		} else {
			return $dataSet[0]['CDOPERADOR'];
		}
	}
	
	public function validatePassword($operator, $password) {
		$dataSourceName = 'operador';
		$conditions = array(
			array(
				'columnName' => 'CDOPERADOR',
				'operator' => '=',
				"value" => $operator
			)
		);
		$dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
		if(md5($password) != $dataSet[0]['CDSENHAOPERWEB']){
			throw new \Exception("Senha inválida", 1);
		}
	}
	
    public function get_maxNrPrPrevReti($nrorg, $campos){
        $sql = "SELECT LPAD(NVL(MAX(PR.NRPRPREVRETI), 0)+1, 4, '0') AS NRPRPREVRETI
                  FROM PREVRETI PR
                 WHERE (PR.CDFILIAL   = :P_CDFILIAL)
                   AND (PR.NRORG      = :P_NRORG)
                   AND (PR.CDSERVFILI = :P_CDSERVFILI)
                   AND (PR.DTPREVRETI = :P_DTPREVRETI)
                   AND (PR.IDPREVRETI = :P_IDPREVRETI)
                   AND (PR.NRREQUEXTR = '0000000000')";

        $params = array(
            "P_CDFILIAL"    => $campos['CDFILIAL'],
            "P_NRORG"       => $nrorg,
            "P_CDSERVFILI"  => $campos['CDSERVFILI'],
            "P_DTPREVRETI"  => $campos['DTPREVRETI'],
            "P_IDPREVRETI"  => $campos['IDPREVRETI']
        );


        $result = $this->entityManager->getConnection()->fetchColumn($sql, $params);
        
        return $result ? $result : false;
    }
}